"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class User(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "email",
        "username",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import reports as reports_6_3_0

        return {
            "org.gel.models.report.avro.User": reports_6_3_0.User,
        }

    __slots__ = [
        "email",
        "username",
        "groups",
        "role",
        "userid",
    ]

    def __init__(
        self,
        email,
        username,
        groups=None,
        role=None,
        userid=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_3_0.User model.

        :param email:
            User email address
        :type email: str
        :param username:
            Username
        :type username: str
        :param groups:
        :type groups: None | list[str]
        :param role:
        :type role: None | str
        :param userid:
            Azure Active Directory immutable user OID
        :type userid: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.3.0"
